package de.bernhardjung.dsaprogramm.gui.action;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.KeyStroke;

import de.bernhardjung.dsaprogramm.gui.Hauptpanel;
import de.bernhardjung.dsaprogramm.gui.Hauptpanel.Warnen;
import de.bernhardjung.dsaprogramm.i18n.I18n;

public class ActionNamenlisteneditor extends AbstractAction {

    /** Der Titel der Aktion. */
    private static final String ACTION_NAME =
        I18n.i18n( "ActionNamenlisteneditor.Name" );
/*
    private static final String MNEMONIC =
        I18n.i18n( "ActionNamenlisteneditor.Mnemonic" );
*/
    private static final String TASTENKUERZEL =
        I18n.i18n( "ActionNamenlisteneditor.Tasten" );

    /** Das Hauptfenster der Anwendung. */
    private final Hauptpanel hauptpanel;

    public ActionNamenlisteneditor( final Hauptpanel dasHauptpanel ) {
        
        super( ACTION_NAME );

        // putValue( MNEMONIC_KEY, Util.getKeyCode( MNEMONIC ) );

        putValue( ACCELERATOR_KEY, KeyStroke.getKeyStroke( TASTENKUERZEL ) );

        hauptpanel = dasHauptpanel;
    }

    public void actionPerformed( final ActionEvent e ) {

        hauptpanel.anzeigen( 
                hauptpanel.getPanelMetaNamenlisten(),
                Warnen.WARNEN );
    }

}
