/*
    This file is part of the TDE Character Generator (TCG).

    TCG is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    TCG is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TCG.  If not, see <http://www.gnu.org/licenses/>.
*/
package de.bernhardjung.dsaprogramm.gui.meta;

import java.util.Collection;
import java.util.Collections;
import java.util.Observable;
import java.util.Observer;

import de.bernhardjung.dsaprogramm.bausteine.Heldenbaustein;

/**
 * Zeigt eine Liste von Heldenbausteinen an, aus denen man beliebig viele
 * auswaehlen kann.
 *
 * @author Bernhard Jung
 */
public abstract class PanelMetaListeHeldenbaustein< T extends Heldenbaustein >
extends PanelMetaListe< T >
implements Observer {

    private final Object observed;

    @SuppressWarnings( "unchecked" )
    PanelMetaListeHeldenbaustein(
            final Object observed ) {

        super( Collections.EMPTY_LIST );

        this.observed = observed;

        aufbauenBenutzeroberflaeche();
    }

    @Override
    protected void aufbauenBenutzeroberflaeche() {

        elemente.clear();

        elemente.addAll( getElemente() );

        super.aufbauenBenutzeroberflaeche();
    }

    abstract Collection< T > getElemente();

    public void update( final Observable o, final Object arg ) {

        if ( observed.equals( arg ) ) {

            aufbauenBenutzeroberflaeche();
        }
    }
}
